/* display all the elements of a document and each text and attributes by nodes */

var root = document.documentElement;

function walk( indent, node ) {
	var tmp = "";
	for ( var i = 0; i < indent; i++ )
		tmp += " ";

	console.log( tmp + node.nodeName );
	
	if ( node.childElementCount == 0 && node.textContent != null ) {
		console.log( tmp + " #TEXT=" + node.textContent );
	}
	
	if ( node.hasAttributes() ) {
		for ( var n = 0; n < node.attributes.length; n++ ) {
			var att = node.attributes.item( n );
			console.log( tmp + " #ATTRIBUTE " + att.nodeName + "=" + att.nodeValue );
		}
	}

	if ( indent < 4 )

		for ( var j = 0; j < node.childElementCount; j++ ) {
			walk( indent + 1, node.children[ j ] );
		}

}

walk( 0, root );
